# Leetcode 134 - Gas station

`Note:`

`Greedy`

- Conclusion:
`curSum`

is the sum of`[i, j]`

. If it’s less than`0`

, it means that any start point between this interval traverse the whole array.- Prove: If there is an
`k`

between`[i,j]`

from which you can traverse the whole array, because you can get to`k`

from`i`

, which means from`i`

you can also traverse the whole array. It contracts our assumption.

- Prove: If there is an
- When
`curSum`

is negative, update`start`

to`i+1`

. - After the forloop ends, if
`totalSum`

is not positive, it means`sum(gas) < sum(cost)`

, return -1. If`totalSum`

is positive, and we finished iteration from an index`start`

, it means we can traverse from`start`

to the`end`

, then the gas we left, can cover our trip from`end`

to`start - 1`

as`totalSum`

is positive.

- Conclusion:

There are n gas stations along a circular route, where the amount of gas at the `ith`

station is `gas[i]`

.

You have a car with an unlimited gas tank and it costs `cost[i]`

of gas to travel from the ith station to its next (i + 1)th station. You begin the journey with an empty tank at one of the gas stations.

Given two integer arrays gas and cost, return the starting gas station’s index if you can travel around the circuit once in the clockwise direction, otherwise return -1. If there exists a solution, it is `guaranteed`

to be `unique`

**Example**

1 | Input: gas = [1,2,3,4,5], cost = [3,4,5,1,2] |

`Brute force`

1 | /** |

`Greedy`

1 | /** |